From 23e9d47377ed6e787fd366a98ba7c34f5d002857 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?=E4=BD=99=E6=98=8C=E5=B9=B3?= <dead.ash@hotmail.com>
Date: Thu, 18 Jun 2020 17:27:32 +0800
Subject: [PATCH V2 2/2] Modify the mechanism that obtain the thread order
 of the toolhelp module , so that the thread order obtained is consistent
 with windows.
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Some software incorrectly uses the way to get the main thread id. 
Coincidentally, the threads of wine and windows return differently.
The list of threads returned by flipping can be consistent with windows.

Signed-off-by: Changping Yu <dead.ash@hotmail.com>
---
 dlls/kernel32/tests/toolhelp.c | 2 --
 dlls/kernel32/toolhelp.c       | 6 +++---
 2 files changed, 3 insertions(+), 5 deletions(-)

diff --git a/dlls/kernel32/tests/toolhelp.c b/dlls/kernel32/tests/toolhelp.c
index 257df34ce4..a394cd2114 100644
--- a/dlls/kernel32/tests/toolhelp.c
+++ b/dlls/kernel32/tests/toolhelp.c
@@ -204,14 +204,12 @@ static void test_main_thread(DWORD curr_pid, DWORD main_tid)
     int                 error;
 
     first_tid = get_thread((void *)curr_pid);
-    todo_wine
     ok(first_tid == main_tid, "check main thread is error, main is %d, %d\n", main_tid, first_tid);
 
     hThread = CreateThread(NULL, 0, get_thread, (void *)curr_pid, 0, &tid);
     error = WaitForSingleObject(hThread, 5000);
     ok(error==WAIT_OBJECT_0, "Thread did not complete within timelimit\n");
 
-    todo_wine
     ok(GetExitCodeThread(hThread, &first_tid), "Could not retrieve ext code\n");;
     ok(first_tid == main_tid, "check main thread is error, main is %d, %d\n", main_tid, first_tid);
 }
diff --git a/dlls/kernel32/toolhelp.c b/dlls/kernel32/toolhelp.c
index d55e8185f2..26a8258e0a 100644
--- a/dlls/kernel32/toolhelp.c
+++ b/dlls/kernel32/toolhelp.c
@@ -359,11 +359,11 @@ static BOOL next_thread( HANDLE hSnapShot, LPTHREADENTRY32 lpte, BOOL first )
     }
     if ((snap = MapViewOfFile( hSnapShot, FILE_MAP_ALL_ACCESS, 0, 0, 0 )))
     {
-        if (first) snap->thread_pos = 0;
-        if (snap->thread_pos < snap->thread_count)
+        if (first) snap->thread_pos = snap->thread_count - 1;
+        if (snap->thread_pos >= 0)
         {
             LPTHREADENTRY32 te = (THREADENTRY32*)&snap->data[snap->thread_offset];
-            *lpte = te[snap->thread_pos++];
+            *lpte = te[snap->thread_pos--];
             ret = TRUE;
         }
         else SetLastError( ERROR_NO_MORE_FILES );
-- 
2.26.1.windows.1

